// IOStream - interface for serialization
//------------------------------------------------------------------------------

// Includes
//------------------------------------------------------------------------------
#include "IOStream.h"
#include <Core/Strings/AString.h>

// Read (AString)
//------------------------------------------------------------------------------
bool IOStream::Read( AString & string )
{
	uint16_t len;
	if ( Read( len ) )
	{
		string.SetLength( len );
		return ( Read( string.Get(), len ) == len );
	}
	return false;
}

// Write (AString)
//------------------------------------------------------------------------------
bool IOStream::Write( const AString & string )
{
	// if we change the string max, we'll need to increase this
	ASSERT( AString::MAX_STRING_LENGTH < 0xFFFF );
	uint16_t len = string.GetLength();
	if ( Write( len ) &&
		 Write( string.Get(), len ) == len )
	{
		return true;
	}
	return false;
}

//------------------------------------------------------------------------------
